#!/usr/bin/perl

# Define Variables

$filename = "/usr/local/etc/httpd/htdocs/xxxx/links.html";
$linksurl = "http://www.xxxx.com/links.html";
$linkscgi = "http://www.xxxx.com/cgi-bin/links.cgi";
$linkstitle = "xn";
$database = "/usr/local/etc/httpd/htdocs/xxxx/database.txt";

# Done
##############################################################################

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<([^>]|\n)*>//g;
   $value =~ s/<//g;
   $value =~ s/>//g;
   $FORM{$name} = $value;
}

if ($FORM{'url'} eq 'http://' || $FORM{'url'} !~ /^(f|ht)tp:\/\/\w+\.\w+/) { 
   &no_url; 
} 
if (!($FORM{'title'})) {
   &no_title;
}

# Enter our tags and sections into an associative array

%sections = ("busi","ӷ~","comp","q","educ","Ш|",
	     "ente","T","gove","Fv",
	     "pers","ӤH","misc","O");

# Suck previous link file into one big string
open(FILE,"$filename");
@lines = <FILE>;
close(FILE);

$i=1;
foreach $line (@lines) {    
    if ($line =~ /\<li\>\<a href\=\"([^\"]+)\">([^<]+)<\/a>/) {
        if ($FORM{'url'} eq $1) {
            &repeat_url;
        }
        $i++;
    }
}

# Open Link File to Output
open (FILE,">$filename");

foreach $line (@lines) { # For every line in our data

   if ($line =~ /<!--time-->/) {
      @months = ('1','2','3','4','5','6',
		 '7','8','9','10','11','12');

      @days = ('P','P@','PG','PT','P|',
	       'P','P');

      ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0,1,2,3,4,5,6];
      if ($sec < 10) { $sec = "0$sec"; }
      if ($min < 10) { $min = "0$min"; }
      if ($hour < 10) { $hour = "0$hour"; }
      if ($mday < 10) { $mday = "0$mday"; }
      $date = "$days[$wday], $months[$mon] $mday, 19$year~  $hour:$min:$sec";
      print FILE "<!--time--><b>̷s@ƥ[Jɶ $date</b><hr>\n";
   }
   elsif ($line =~ /<!--number-->/) {
      print FILE "<!--number--><b>@ <i>$i</i> .</b><br>\n";
   }
   else {
       print FILE $line;
   }

   foreach $tag ( keys %sections) { # For every tag 
      if ( ($FORM{'section'} eq $sections{$tag}) && 
         ($line =~ /<!--$tag-->/) ) {

         print FILE "<li><a href=\"$FORM{'url'}\">$FORM{'title'}</a>\n"; 
      }
   }
}

close (FILE);

# Return Link File
print "Location: $linksurl\n\n";

if ($database ne '') {
    open (DATABASE,">>$database");
    print DATABASE "$FORM{'url'}\n";
    close(DATABASE);
}

sub no_url {
   print "Content-type: text/html\n\n";
   print "<html><head><title>~: SJ}</title></head>\n";
   print "<body bgcolor=#FFFFFF text=#000000><center>";
   print "<h1>SJ}</h1></center>\n";
   print "zSJx}Ϊ̱zJ}~.<p>\n";  
   print "<form method=POST action=\"$linkscgi\">\n";
   print "<input type=hidden name=\"title\" value=\"$FORM{'title'}\">\n";
   print "<input type=hidden name=\"section\""; 
   print "value=\"$FORM{'section'}\">\n";
   print "пJx}: <input type=text name=\"url\" size=50><p>\n";
   print "<input type=submit value=nJ> * <input type=reset value=>\n";
   print "<hr>\n";
   print "<ul>";
   print "<font size=1>";
   print "<li><a href=\"$linksurl\">$linkstitle</a>\n";
   print "</font></ul></form></body></html>\n";

   exit;
}

sub no_title {
   print "Content-type: text/html\n\n";
   print "<html><head><title>~: SDD</title></head>\n";
   print "<body bgcolor=#FFFFFF text=#000000><center>";
   print "<h1>SDD</h1></center>\n";
   print "zѤFJzDD<p>\n";
   print "<form method=POST action=\"$linkscgi\">\n";
   print "<input type=hidden name=\"url\" value=\"$FORM{'url'}\">\n"; 
   print "<input type=hidden name=\"section\"";
   print "value=\"$FORM{'section'}\">\n";
   print "пJDD: <input type=text name=\"title\" size=50><p>\n";
   print "<input type=submit value=nJ> * <input type=reset value=>\n";
   print "<hr>\n";
   print "<ul>";
   print "<font size=1>";
   print "<li><a href=\"$linksurl\">$linkstitle</a>\n";
   print "</font></ul></form></body></html>\n";

   exit;
}

sub repeat_url {
   print "Content-type: text/html\n\n";
   print "<html><head><title>~: }</title></head>\n";
   print "<body bgcolor=#FFFFFF text=#000000><center><h1>}</h1></center>\n";
   print "藍_A}wgnJFALkƵnJC\n";
   print "<ul>";
   print "<font size=1>";
   print "<li><a href=\"$linksurl\">$linkstitle</a>\n";
   print "</font></ul></body></html>\n";

   exit;
}
